assert(package.loadlib(_SELF, 'luaopen_filedir'))()
local ffi = require 'ffi'
ffi.cdef[[
bool exists (const char*) ;
bool isfile (const char*) ;
bool isdir (const char*) ;
bool fcopy (const char*, const char*, int) ;
bool fmove (const char*, const char*) ;
unsigned int fsize (const char*) ;
unsigned int ftime (const char*, int) ;
bool mkdir2 (const char*) ;
bool rmdir (const char*) ;
void chdir (const char*) ;
char* getcwd (char*, int) ;
char* fullpath (const char*, char*, int) ;
]]

os.pathsep = jit.os=='Windows' and '\\' or '/'
os.delete = os.remove
os.exists, os.isfile, os.isdir  = ffi.C.exists, ffi.C.isfile, ffi.C.isdir
os.move, os.filesize = ffi.C.fmove, ffi.C.fsize
os.chdir, os.mkdir, os.rmdir = ffi.C.chdir, ffi.C.mkdir2, ffi.C.rmdir

function os.realpath (path)
return ffi.string(ffi.C.fullpath(path, ffi.new('char[?]', 512), 511))
end

function os.getcwd ()
return ffi.string(ffi.C.getcwd(ffi.new('char[?]', 512), 511))
end

function os.filectime (name) 
return ffi.C.ftime(name,0) 
end

function os.fileatime (name) 
return ffi.C.ftime(name,1) 
end

function os.filemtime (name) 
return ffi.C.ftime(name,2) 
end

function os.copy (old, new, failIfExists)
return ffi.C.fcopy(old, new, failIfExists or false)
end

function os.suffix  (s) 
return s:match('%.(%w+)$'):lower()
end

function os.dirname (s)
local i = s:crfind('\\') or s:crfind('/')
if not i then return s
else return s:sub(1,i)
end end

function os.basename (s)
local i = s:crfind('\\') or s:crfind('/')
if not i then return s
else return s:sub(i+1)
end end

function io.tonativefile (fp)
return ffi.cast('struct FILE**', fp)[0]
end

return os