require 'strings'
require 'tables'
require 'filedir'
require 'key'
require 'mouse'
require 'window'
require 'thread'
require 'messaging'
require 'serialization'
require 'audio'
require 'speech'

print('Memory used by lua : ', 1024*collectgarbage('count'))

audio.init()

print('List of devices:', device.count, ' found, default is ', device.default)
for _, info in ipairs(device.list()) do
print(info.id, info.lowLatency, info.highLatency, info.name)
end

print('Opening')
local dev = device.open(10, 44100, 2, 0.05)
print('Starting')
dev:start()

local sample = audio.loadSample('test2.ogg')
local stream = audio.loadStream('test.ogg')
stream.pitch = 1.1
stream.loop = -1

window.open()
while key.wait() ~= 27 do end
collectgarbage()

stream:stop()
dev:close()
audio.free()
