#ifndef _____AUDIO_H_____
#define _____AUDIO_H_____
#include "global.h"
#include<al/al.h>
#include<al/alc.h>
#include<al/alext.h>
#include<sdl/sdl_thread.h>
#include<sdl/sdl_mutex.h>

#define FORMAT_FLOAT 6
#define FORMAT_S16 2

#define STREAM_NBUFFERS 5
#define STREAM_BUFLEN 2048
#define STREAM_SLEEPTIME 20
#define CHF_AUTOFREE 0x0001
#define AL_LISTENER_UP 0x1A00
#define AL_PANNING 0x1A01
#define AL_AUTOFREE 0x1a02

typedef struct audioIO {
int(*read)(void* udata, int format, void* buf, int len) ;
int(*seek)(void* udata, int pos, int ance) ;
void*(*close)(void* udata, void* udata2, struct audioIO* io) ;
} audioIO;

typedef struct {
int frames;
int samplerate;
int channels;
int format;
} audioInfo;

typedef struct {
ALCdevice* dev;
ALCcontext* ctx;
double dx, dy, dz, ux, uy, uz;
} device;

typedef struct {
ALuint src;
unsigned short type;
unsigned short flags;
void* handle;
audioIO io;
int loop, channels, sampleRate, totalLength, bufferIndex, stopped;
SDL_mutex* mutex;
SDL_Thread* thread;
} stream;

typedef struct {
ALuint src;
unsigned short type;
unsigned short flags;
} channel;

#endif

