require 'filedir'
local basedir = _SELF:match('^(.*[/\\]).-$')
local files = {}
local args = {...}
local vmfile = nil
local outfile = 'b.exe'
local debugging = false
local i, n = 0, #args

while i<n do
i = i+1
local arg = args[i]
if arg == '-g' then 
debugging = true
elseif arg == '-o' then
i = i+1
outfile = args[i]
elseif arg=='-b' then
i = i+1
vmfile = args[i]
else break
end end
for i = i, #args do
table.insert(files, args[i])
end

function parse (file, files)
--print(string.format('Parsing %s...', file))
local fp = io.open(file, 'rb')
if not fp then return end
local str = fp:read('*a')
fp:close()
for _, name in str:gmatch([[require%s*%(?(['"])(.-)%1]]) do
local file = parseName(name)
if file and not files[file] then
local entry = string.format('%s=%s', name, file)
table.insert(files, entry)
files[file]=true
end end 
end

function parseName (name)
if name=='ffi' or name=='bit' then return end
local file = name:gsub('%.', os.pathsep)
local fn = file..'.lua'
if os.isfile(fn) then return fn end
fn = file..'.lc'
if os.isfile(fn) then return fn end
fn = basedir..'libs'..os.pathsep..file..'.lua'
if os.isfile(fn) then return fn end
fn = basedir..'libs'..os.pathsep..file..'.lc'
if os.isfile(fn) then return fn end
end

i = 0
while i<#files do
i=i+1
local file = files[i]:match('=(.*)$') or files[i]
parse(file, files)
end

local cmdline = basedir ..'lua2exe.exe -i'
if debugging then cmdline = cmdline..' -g' end
if vmfile then cmdline=cmdline..' -b '..vmfile end
if outfile then cmdline=cmdline..' -o '..outfile end
--print(string.format('Output %s...', outfile))
--print(cmdline)
local fp = io.popen(cmdline,'w')
fp:write(table.concat(files, '\n'))
fp:flush()
fp:close()
