#ifndef _____GLOBAL_H_____
#define _____GLOBAL_H_____

#if defined WIN32 || defined WIN64 || defined _WIN32 || defined _WIN64 || __WIN32 || defined __WIN64 || defined __WIN32__ || defined __WIN64__
#define OS_WINDOWS
#endif

#ifdef OS_WINDOWS
#define export __declspec(dllexport)
#else
#define export extern
#endif

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))

#define regt(L,n,f) lua_pushcclosure(L,f,0); lua_setfield(L,-2,n)
#define lua_getreg(L,n) lua_getfield(L, LUA_REGISTRYINDEX, n)
#define lua_setreg(L,n) lua_setfield(L, LUA_REGISTRYINDEX, n)
#define streq(a,b) (0==strcmp((a),(b)))

#define threadNew(f,u) SDL_CreateThread(f,u)
#define threadJoin(t) SDL_WaitThread(t,NULL)
#define sleep(n) SDL_Delay(n)

#define lockNew(l) l = SDL_CreateMutex()
#define lockAcquire(l) SDL_mutexP(l)
#define lockRelease(l) SDL_mutexV(l)
#define lockDestroy(l) SDL_DestroyMutex(l)

#define semNew(s,i) s = SDL_CreateSemaphore(i)
#define semAcquire(s) SDL_SemWait(s)
#define semRelease(s) SDL_SemPost(s)
#define semTryAcquire(s,t) SDL_SemWaitTimeout(s,t)
#define semDestroy(s) SDL_DestroySemaphore(s)

#define condNew(c,l) c = SDL_CreateCond()
#define condWait(c,l) SDL_CondWait(c,l)
#define condNotify(c,l) SDL_CondBroadcast(c)
#define condDestroy(c) SDL_DestroyCond(c)

#endif
