#include "global.h"
#include<lua/lua.h>
#include<lua/lauxlib.h>
#include<lua/lualib.h>

static inline void* ptr (lua_State* L, int idx) {
return lua_type(L,idx)>LUA_TTHREAD?
*(void**)lua_topointer(L,idx)
:lua_topointer(L,idx);
}

static int ljref (lua_State* L) {
lua_pushlightuserdata(L, lua_topointer(L,1));
lua_pushvalue(L, -1);
lua_pushvalue(L,1);
lua_rawset(L, LUA_REGISTRYINDEX);
return 1;
}

static int ljunref (lua_State* L) {
lua_pushlightuserdata(L, ptr(L,1));
lua_pushnil(L);
lua_rawset(L, LUA_REGISTRYINDEX);
return 0;
}

static int ljgetref (lua_State* L) {
lua_pushlightuserdata(L, ptr(L,1));
lua_rawget(L, LUA_REGISTRYINDEX);
return 1;
}

static int ljptr (lua_State* L) {
lua_pushinteger(L, ptr(L,1));
return 1;
}

int ljp2l (lua_State* L) {
switch(lua_type(L,1)) {
case LUA_TNUMBER: lua_pushlightuserdata(L, lua_tointeger(L,1)); break;
case LUA_TSTRING: lua_pushlightuserdata(L, lua_tostring(L,1)); break;
case LUA_TBOOLEAN: lua_pushlightuserdata(L, lua_toboolean(L,1)?1:0); break;
default: lua_pushlightuserdata(L, lua_topointer(L,1)); break;
}
return 1;
}

int export luaopen_ljrefs (lua_State* L) {
lua_getglobal(L,"jit");
regt(L, "ref", ljref);
regt(L, "unref", ljunref);
regt(L, "getref", ljgetref);
regt(L, "ptr", ljptr);
regt(L, "i2l", ljp2l);
return 1;
}
