#include "global.h"
#include<lua/lua.h>
#include<lua/lauxlib.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int loadembed (lua_State*) ;
extern char selfname[300];

void luaL_newclass (lua_State* L, const char* name) {
luaL_newmetatable(L,name);
lua_pushvalue(L,-1);
lua_setfield(L, -2, "__index");
lua_pushstring(L,name);
lua_setfield(L, -2, "__name");
}

int luaL_getmetaname  (lua_State* L) {
if (lua_type(L,-1)!=LUA_TSTRING) return 0;
lua_pushvalue(L,-1);
lua_gettable(L, LUA_REGISTRYINDEX);
if (lua_type(L,-1)==LUA_TTABLE) { lua_remove(L,-2); return 1; }
lua_pop(L,1);
lua_pushvalue(L,-1);
lua_gettable(L, LUA_GLOBALSINDEX);
if (lua_type(L,-1)==LUA_TTABLE) { lua_remove(L,-2); return 1; }
lua_pop(L,2);
return 0;
}

int luaL_checkboolean (lua_State* L, int n) {
luaL_checktype(L, n, LUA_TBOOLEAN);
return lua_toboolean(L,n);
}

int luaL_optboolean (lua_State* L, int n, int b) {
if (lua_isnoneornil(L,n)) return b;
luaL_checktype(L, n, LUA_TBOOLEAN);
return lua_toboolean(L,n);
}

void luaL_checktable (lua_State* L, int n) {
luaL_checktype(L, n, LUA_TTABLE);
}

int luaL_opttable (lua_State* L, int n, int idx) {
if (lua_isnoneornil(L,n)) return idx;
luaL_checktype(L,n,  LUA_TTABLE);
return n;
}

void luaL_checkfunction  (lua_State* L, int n) {
luaL_checktype(L, n, LUA_TFUNCTION);
}

int luaL_optfunction  (lua_State* L, int n, int idx) {
if (lua_isnoneornil(L,n)) return idx;
luaL_checktype(L, n, LUA_TFUNCTION);
return n;
}

void lua_pushudata (lua_State* L, void* buf, int len, const char* name) {
void* p = lua_newuserdata(L, len);
memcpy(p, buf, len);
luaL_newmetatable(L,name);
lua_setmetatable(L,-2);
}

void* luaL_newudata (lua_State* L, int size, const char* name) {
void* p = lua_newuserdata(L,size);
luaL_newmetatable(L,name);
lua_setmetatable(L,-2);
return p;
}

int lua_getbacktrace (lua_State* L) {
lua_getglobal(L, "debug");
lua_getfield(L, -1, "traceback");
lua_pushvalue(L,-3);
lua_pushinteger(L,1);
return !lua_pcall(L, 2, 1,0);
}

lua_State* lua_open2 (lua_State* L, lua_State* src) {
if (!L) {
L = lua_open();
luaL_openlibs(L);
}
if (src) {
lua_getreg(src, "embeddedfiles");
lua_interstate_copy(L, src, lua_gettop(src));
lua_pushvalue(L,-1);
lua_setreg(L, "embeddedfiles");
}
else lua_getreg(L, "embeddedfiles");
lua_setglobal(L, "embeddedfiles");
lua_pushcclosure(L, loadembed, 0);
lua_setglobal(L, "loadembed");
lua_pushstring(L, selfname);
lua_setglobal(L, "_SELF");
#include "loader.lb"
return L;
}
