#include "global.h"
#include "lua2exe.h"
#include<lua/lua.h>
#include<lua/lauxlib.h>
#include<zlib.h>
#include<sdl/sdl.h>
#include<stdio.h>
#include<string.h>
#undef main

int lua_getbacktrace (lua_State* ) ;

#ifdef OS_WINDOWS
#include "windows/getSelfName.c"
#elif defined OS_LINUX
#include "linux/getSelfName.c"
#else
#error Platform currently unsupported
#endif

char selfname[300] = {0};
int argc; char** argv;
unsigned int mainThreadId = 0;
char* key = NULL;
int keylen = 0;

static int loadembedded (lua_State* L, const char* name, unsigned long offset) {
FILE* fp = fopen(selfname, "rb");
if (!fp) { lua_pushstring(L, "Unable to read into the executable file"); return -3; }
int length;
const char* data = lzqReadData(fp, offset, &length, key, keylen);
fclose(fp);
if (!data) { lua_pushstring(L, "Unable to read into the executable file"); return -4; }
char name2[257];
snprintf(name2, 256, "@%s", name);
int re = luaL_loadbuffer(L, data, length, name2);
free(data);
return re;
}

int loadembed (lua_State* L) {
const char* name = luaL_checkstring(L,1);
int offset = luaL_optint(L,2,-1);
if (offset<0) {
if (key) free(key);
keylen = strlen(name);
key = malloc(keylen+1);
memcpy(key, name, keylen+1);
return 0;
}
if (loadembedded(L, name, offset)) return lua_error(L);
else return 1;
}

int main (int _argc, char** _argv) {
argc = _argc; argv = _argv;
mainThreadId = SDL_ThreadID();
if (!getSelfName(selfname,300)) return 1;

lua_State* L = lua_open();
luaL_openlibs(L);
lua_settop(L,0);

int n, offset, length;
FILE* fp = fopen(selfname, "rb");
if (!fp) return 1;
lzqOpenRead(fp, &offset);
const char* data = lzqReadData(fp, offset, &length, key, keylen);
if (!data) return 1;

char firstname[256]={0};
unsigned long firstoffset=0;
lzqLoadLuaTable(L, data, length, firstname, &firstoffset);
free(data);
lua_setreg(L, "embeddedfiles");

lua_open2(L, NULL);
lua_settop(L,0);
lua_newtable(L);
for (n=0; n<argc; n++) {
lua_pushstring(L, argv[n]);
lua_rawseti(L, -2, n);
}
lua_setglobal(L, "arg");
lua_settop(L,0);
lua_pushcclosure(L, lua_getbacktrace, 0);
if (loadembedded(L, firstname, firstoffset)) goto luaerror;
for (n=1; n<argc; n++) lua_pushstring(L, argv[n]);
if (lua_pcall(L, argc -1, LUA_MULTRET, -1 -argc)) goto luaerror;
lua_close(L);
return 0;

luaerror:
fprintf(stderr, "%s", lua_tostring(L,-1)); 
return 3;
}
