#include "global.h"
#include<lua/lua.h>
#include<lua/lualib.h>
#include<lua/lauxlib.h>
#include<stdio.h>
#include<stdlib.h>

typedef struct {
lua_State* L;
void *lock, *wait;
int refs;
} Messager;

static int messager_create (lua_State* L) {
Messager* m = malloc(sizeof(Messager));
if (!m) return 0;
m->refs = 1;
m->L = lua_open();
if (!m->L) { free(m); return 0; }
lockNew(m->lock);
condNew(m->wait, m->lock);
luaopen_table(m->L);
lua_settop(m->L,0);
lua_getglobal(m->L, "table");
lua_getfield(m->L, -1, "insert");
lua_getfield(m->L, -2, "remove");
lua_remove(m->L,1);
lua_pushudata(L, &m, sizeof(Messager*), "Messager");
return 1;
}

static int messager_fetch (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,2);
int top = lua_gettop(L);
lockAcquire(m->lock);
while(1){
for (int i=2; i<=top; i++) {
lua_interstate_copy(m->L, L, i);
lua_rawget(m->L, LUA_GLOBALSINDEX);
if (lua_isnil(m->L,-1)) lua_pop(m->L,1);
else {
lua_interstate_copy(L, m->L, lua_gettop(m->L));
lua_pop(m->L,1);
lua_pushvalue(L,i);
lockRelease(m->lock);
return 2;
}}
condWait(m->wait, m->lock);
}}

static int messager_set (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,3);
lockAcquire(m->lock);
lua_interstate_copy(m->L, L, 2);
lua_interstate_copy(m->L, L, 3);
lua_rawset(m->L, LUA_GLOBALSINDEX);
condNotify(m->wait, m->lock);
lockRelease(m->lock);
return 0;
}

static int messager_get (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,2);
lockAcquire(m->lock);
lua_interstate_copy(m->L, L, 2);
lua_rawget(m->L, LUA_GLOBALSINDEX);
lua_interstate_copy(L, m->L, lua_gettop(m->L));
lua_pop(m->L,1);
lockRelease(m->lock);
return 1;
}

static int messager_pop (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,2);
int count, top = lua_gettop(L);
lockAcquire(m->lock);
while(1){
for (int i=2; i<=top; i++) {
lua_interstate_copy(m->L, L, i);
lua_rawget(m->L, LUA_GLOBALSINDEX);
if (lua_type(m->L,-1)!=LUA_TTABLE || (count=lua_objlen(m->L,-1))<=0) lua_pop(m->L,1);
else {
lua_pushvalue(m->L,2);
lua_pushvalue(m->L,-2);
lua_pushinteger(m->L,1);
lua_call(m->L, 2, 1);
lua_interstate_copy(L, m->L, lua_gettop(m->L));
lua_pushvalue(L,i);
lua_pushinteger(L, count -1);
lua_pop(m->L,2);
lockRelease(m->lock);
return 3;
}}
condWait(m->wait, m->lock);
}}

static int messager_push (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,3);
lockAcquire(m->lock);
lua_pushvalue(m->L,1);
lua_interstate_copy(m->L, L, 2);
lua_rawget(m->L, LUA_GLOBALSINDEX);
if (lua_type(m->L,-1)!=LUA_TTABLE) {
lua_pop(m->L,1);
lua_newtable(m->L);
lua_interstate_copy(m->L, L, 2);
lua_pushvalue(m->L,-2);
lua_rawset(m->L, LUA_GLOBALSINDEX);
}
lua_interstate_copy(m->L, L, 3);
lua_call(m->L, 2, 0);
condNotify(m->wait, m->lock);
lockRelease(m->lock);
return 0;
}

static int messager_poll (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,2);
int count, top = lua_gettop(L);
lockAcquire(m->lock);
for (int i=2; i<=top; i++) {
lua_interstate_copy(m->L, L, i);
lua_rawget(m->L, LUA_GLOBALSINDEX);
if (lua_type(m->L,-1)!=LUA_TTABLE || (count=lua_objlen(m->L,-1))<=0)  lua_pop(m->L,1);
else {
lua_pushvalue(m->L,2);
lua_pushvalue(m->L,-2);
lua_pushinteger(m->L,1);
lua_call(m->L, 2, 1);
lua_interstate_copy(L, m->L, lua_gettop(m->L));
lua_pushvalue(L,i);
lua_pushinteger(L, count -1);
lua_pop(m->L,2);
lockRelease(m->lock);
return 3;
}}
lockRelease(m->lock);
return 0;
}

static int messager_count (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,2);
lockAcquire(m->lock);
lua_interstate_copy(m->L, L, 2);
lua_rawget(m->L, LUA_GLOBALSINDEX);
if (lua_type(m->L,-1)!=LUA_TTABLE) {
lua_pushinteger(L,0);
return 1;
}
lua_pushinteger(L, lua_objlen(m->L,-1));
lua_pop(m->L,1);
lockRelease(m->lock);
return 1;
}

static int messager_top (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
luaL_checkany(L,2);
lockAcquire(m->lock);
int count=0;
lua_interstate_copy(m->L, L, 2);
lua_rawget(m->L, LUA_GLOBALSINDEX);
if (lua_type(m->L,-1)!=LUA_TTABLE || (count=lua_objlen(m->L,-1))<=0) {
lua_pushnil(L);
lua_pushnil(L);
lua_pushinteger(L,0);
return 3;
}
lua_pushinteger(m->L,1);
lua_gettable(m->L, -2);
lua_interstate_copy(L, m->L, lua_gettop(m->L));
lua_pushvalue(L,2);
lua_pushinteger(L,count);
lua_pop(m->L,2);
lockRelease(m->lock);
return 3;
}

static int messager_index (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
if (lua_type(L,2)==LUA_TSTRING && luaL_getmetafield(L, 1, lua_tostring(L,2))) return 1;
else return messager_get(L);
}

static int messager_newindex (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
if (lua_type(L,2)==LUA_TSTRING && luaL_getmetafield(L, 1, lua_tostring(L,2))) return luaL_error(L, "Read only field");
return messager_set(L);
}

static int messager_gc (lua_State* L) {
Messager* m = *(Messager**)luaL_checkudata(L, 1, "Messager");
if (!m || --m->refs>0) return 0;
if (m->L) lua_close(m->L);
free(m);
}

int export luaopen_messaging (lua_State* L) {
luaL_newclass(L, "Messager");
regt(L, "new", messager_create);
regt(L, "set", messager_set);
regt(L, "get", messager_get);
regt(L, "fetch", messager_fetch);
regt(L, "push", messager_push);
regt(L, "pop", messager_pop);
regt(L, "poll", messager_poll);
regt(L, "top", messager_top);
regt(L, "count", messager_count);
regt(L, "free", messager_gc);
regt(L, "__index", messager_index);
regt(L, "__newindex", messager_newindex);
regt(L, "__gc", messager_gc);
return 1;
}
