#include "global.h"
#include<sdl/sdl.h>
#include<stdio.h>

typedef struct {
SDL_TimerID timerId;
int once;
} Timer;

static int wmHandleEvent (SDL_Event* ev) {
static z = 0;
if (ev->type == SDL_KEYDOWN && ev->key.keysym.sym == SDLK_F4 && ev->key.keysym.mod&(KMOD_CTRL|KMOD_ALT)) {
wmPostQuitEvent();
return 0;
}
else if (ev->type==23) {
int(*f)(void*) = ev->user.data1;
if (f) ev->user.code = f(ev->user.data2);
return !!ev->user.code;
}
// other events
return 1;
}

void export wmPostEvent (SDL_Event* ev) {
while (SDL_PushEvent(ev));
}

void export wmPostQuitEvent (void) {
SDL_Event e;
e.type = SDL_QUIT;
wmPostEvent(&e);
}

static int tcPostEmptyEvent (int interval, void* param) {
SDL_Event e;
e.type = 21;
wmPostEvent(&e);
return 0;
}

static int tcPostTimerEvent (int interval, void* param) {
SDL_Event e;
e.type = 22;
e.user.code = interval;
e.user.data1 = param;
wmPostEvent(&e);
return interval;
}

static int tcPostTimerEventOnce (int interval, void* param) {
return tcPostTimerEvent(0, param);
}

SDL_TimerID export wmSetTimer (int timeout, void* param, int once) {
return SDL_AddTimer(timeout, once? tcPostTimerEventOnce : tcPostTimerEvent, param);
}

int export wmWaitEvent (SDL_Event* ev, int timeout) {
SDL_TimerID timerId = 0;
if (timeout>0) timerId = SDL_AddTimer(timeout, tcPostEmptyEvent, NULL);
while (SDL_WaitEvent(ev)) {
if (timerId) SDL_RemoveTimer(timerId);
if (wmHandleEvent(ev)) return 1;
}
return 0;
}

int export wmPollEvent (SDL_Event* ev) {
while (SDL_PollEvent(ev)) {
if (wmHandleEvent(ev)) return 1;
}
return 0;
}


