#include<windows.h>

typedef struct {
HANDLE h;
int state;
WIN32_FIND_DATA fd;
} fileinfo;

static unsigned long filetimeTo1970 (unsigned long long l) {
static unsigned long long rep = 0;
if (!rep) {
SYSTEMTIME st1 = { 1970, 1, 0, 1, 0, 0, 0, 0 };
FILETIME ft1;
SystemTimeToFileTime(&st1, &ft1);
rep = (((unsigned long long)ft1.dwHighDateTime)<<32) | ft1.dwLowDateTime;
}
return ((l-rep)/10000000LL);
}

static int findnext (lua_State* L) {
fileinfo* fi = lua_topointer(L,1);
switch(fi->state) {
case 0 :
fi->h = FindFirstFile(fi->fd.cFileName, &fi->fd);
if (!fi->h) goto _2;
case 1 : {
unsigned long long ft = (((unsigned long long)fi->fd.ftLastWriteTime.dwHighDateTime)<<32) | fi->fd.ftLastWriteTime.dwLowDateTime;
unsigned long long sz = ((unsigned long long)(fi->fd.nFileSizeHigh)<<32LL) | fi->fd.nFileSizeLow;
lua_settop(L,0);
lua_pushstring(L, fi->fd.cFileName);
lua_pushboolean(L, 0!=(fi->fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY));
lua_pushnumber(L, filetimeTo1970(ft));
lua_pushnumber(L, sz);
fi->state = 1+(!FindNextFile(fi->h, &fi->fd));
return 4;
}
case 2 : _2:
if (fi->h) FindClose(fi->h);
free(fi);
default :
return 0;
}}

static int findfirst (lua_State* L) {
fileinfo* fi = malloc(sizeof(fileinfo));
memset(fi, 0, sizeof(fileinfo));
strcpy(fi->fd.cFileName, luaL_optstring(L,1,"*"));
lua_settop(L,0);
lua_getreg(L, "_____findnextfile");
lua_pushlightuserdata(L,fi);
return 2;
}

BOOL export exists (const char* fn) {
DWORD n = GetFileAttributes(fn);
return n!=INVALID_FILE_ATTRIBUTES;
}

BOOL export isfile (const char* fn) {
DWORD n = GetFileAttributes(fn);
return (n!=INVALID_FILE_ATTRIBUTES && 0==(n&FILE_ATTRIBUTE_DIRECTORY));
}

BOOL export isdir (const char* fn) {
DWORD n = GetFileAttributes(fn);
return (n!=INVALID_FILE_ATTRIBUTES && 0!=(n&FILE_ATTRIBUTE_DIRECTORY));
}

BOOL export fcopy (const char* src, const char* dst, int failIfExists) {
return CopyFileA(src,dst,failIfExists);
}

BOOL export fmove (const char* src, const char* dst) {
return MoveFileExA(src,dst, MOVEFILE_COPY_ALLOWED);
}

unsigned int export fsize (const char* fn) {
HANDLE hFile = CreateFileA(fn, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
DWORD size = -1;
if (hFile&&hFile!=INVALID_HANDLE_VALUE) {
size = GetFileSize(hFile,NULL);
CloseHandle(hFile);
}
return size;
}

unsigned long export ftime (const char* fn, int type) {
unsigned long long l = 0;
FILETIME ft;
HANDLE h = CreateFile(fn, GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
if (h==INVALID_HANDLE_VALUE) return 0;
if (GetFileTime(h, type==0?&ft:0, type==1?&ft:0, type==2?&ft:0)) l = (((unsigned long long)ft.dwHighDateTime)<<32) | ft.dwLowDateTime;
CloseHandle(h);
return filetimeTo1970(l);
}

BOOL export chdir (const char* path) {
return SetCurrentDirectoryA(path);
}

BOOL export mkdir2 (const char* path, int reserved) {
return CreateDirectoryA(path,NULL);
}

BOOL export rmdir (const char* path) {
return RemoveDirectoryA(path);
}

char* export getcwd (char* path, int length) {
GetCurrentDirectoryA(length, path);
return path;
}

char* export fullpath (const char* path, char* real, int length) {
if (GetFullPathNameA(path, length, real, NULL)<=0) return 0;
return real;
}

