--[[
function calc (f, ...)
local time = os.clock()
f(...)
time = os.clock()-time
print(time)
end

require 'window'
require 'key'
window.open()
while key.wait()~=27 do end
]]

local ffi = require 'ffi'
ffi.cdef[[
typedef struct {
unsigned long addr;
unsigned short port;
} Address;
int SDL_Init (int) ;
int SDLNet_Init (void) ;
int enet_initialize (void) ;
int SDLNet_ResolveHost (Address*, const char*, unsigned short) ;
int enet_address_set_host (Address*, const char*) ;
]]
local sdl, sdlnet, enet = ffi.load('sdl'), ffi.load('SDL_net'), ffi.load('enet')
print(sdl.SDL_Init(0))
print(sdlnet.SDLNet_Init())
print(enet.enet_initialize())
local addr = ffi.new('Address')
print(sdlnet.SDLNet_ResolveHost(addr, 'localhost', 1234))
print(string.format('%08X, %d', addr.addr, addr.port))
addr.port = 1234
print(enet.enet_address_set_host(addr, 'localhost'))
print(string.format('%08X, %d', addr.addr, addr.port))
